2 # Make sure that `tail -n0 -f' and `tail -c0 -f' sleep
3 # rather than doing what amounted to a busy-wait.
5 # Copyright (C) 2003, 2006 Free Software Foundation, Inc.
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
23 # This bug was fixed for 5.0.91
24 # It skips the test if your system lacks a /proc/$pid/status
25 # file, or if its contents don't look right.
27 if test "$VERBOSE" = yes; then
35 grep '^State:[ ]*[S]' /proc
/$pid/status
> /dev
/null
2>&1 || \
37 echo "$0:/proc/$pid/status: missing or 'different': skipping this test" 1>&2
43 t0
=`echo "$0"|sed 's,.*/,,'`.tmp
; tmp
=$t0/$$
44 trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
45 trap '(exit $?); exit $?' 1 2 13 15
48 mkdir
-p $tmp || framework_failure
=1
49 cd $tmp || framework_failure
=1
50 touch empty || framework_failure
=1
51 echo anything
> nonempty || framework_failure
=1
53 if test $framework_failure = 1; then
54 echo "$0: failure in testing framework" 1>&2
60 for file in empty nonempty
; do
62 tail --sleep=4 -${c_or_n} 0 -f $file &
65 set _
`sed -n '/^State:[ ]*\([^ ]\)/s//\1/p' /proc/$pid/status`
66 shift # Remove the leading `_'.
70 *) echo $0: process
in unexpected state
: $state 1>&2; fail
=1 ;;
76 (exit $fail); exit $fail